﻿using System;
using System.IO;

namespace CopyFilesKeepPathStructure
{
    class Program
    {
        static void Main(string[] args)
        {
            Console.WriteLine("Root source path");
            string rootSourcePath = Console.ReadLine();
            //string rootSourcePath = @" c:\folder";

            Console.WriteLine("Root destination path");
            string rootDestinationPath = Console.ReadLine();
            //string rootDestinationPath = @"c:\copyFolder";

            Console.WriteLine($"File with list of files to be copied:");
            string fileWithListOfFilesToBeCopied = Console.ReadLine();
            if (!(fileWithListOfFilesToBeCopied is null) && !(rootSourcePath is null))
            {
                string[] listOfSourceFiles = File.ReadAllLines(fileWithListOfFilesToBeCopied);
                //string[] listOfSourceFiles = File.ReadAllLines(@"C:\files.txt");

                foreach (string sourceFile in listOfSourceFiles)
                {
                    string folderStructure = sourceFile.Substring(rootSourcePath.Length,
                        sourceFile.Length - rootSourcePath.Length);
                    string destinationFile = rootDestinationPath + folderStructure;
                    Directory.CreateDirectory(Path.GetDirectoryName(destinationFile) ?? string.Empty);
                    File.Copy(sourceFile, destinationFile, true);
                    Console.WriteLine($"Source: {sourceFile}, destination: {destinationFile}");
                }
            }

            Console.WriteLine($"Press any key...");
            Console.ReadKey();
        }
    }
}